//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include <fastmath.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        Application->OnIdle = IdleLoop;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::IdleLoop(TObject*, bool& done)
{
        done = false;

        //wglMakeCurrent(hdc, hrc);
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
        DrawScene();
        Perspective();
        glFlush();
        SwapBuffers(hdc);
        fps += 1;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *)
{
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
        glFlush();
        DrawScene();

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *)
{
        bitmap = new Graphics::TBitmap;
        SetPixelFormatDescr();
        randomize();
        startoflist = glGenLists(2);

//      initialize variables of:
//   1) window sizes and eye parameters

        size       =  10.0f;
        Top        =  0;
        Left       =  0;
        Width      =  GetSystemMetrics(SM_CXSCREEN);
        Height     =  GetSystemMetrics(SM_CYSCREEN);
        w          =  Width;
        h          =  Height;

        hy         =  200;
        hx         =  400;
        hz         =  400;
        alf        = -2.356;
        tht        = -0.333;

//   3) GL drawing scaling factors

        nRange     =  800.0;
        Near       = -1000.0;
        Far        =  1000.0;
        ka         =  20;
        tnum       =  1;
        ntcl.g     =  64;
        mode       =  GL_QUADS;
//    3.5) Function scale factors

        a = 20.0;
        b = 1.0;
        c = 1.0;
        t = 0.0;


//      That's the end of all variable inits;
//      OpenGL initializations:

        glViewport(0, 0, w, h);
        glEnable(GL_DEPTH_TEST);
        glDepthRange(0.0, 1.0);
        glDepthFunc(GL_LESS);
        glDisable(GL_CULL_FACE);
        glEnable(GL_BLEND);
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
        glClearColor(0.0f, 0.0f, 0.0f, 0.0f);

//      OpenGL-Related functions:

        SetupTextures();
        Light();

        Objects3D[0] = gluNewQuadric();                       //   }
        gluQuadricTexture(Objects3D[0], GL_TRUE);             //   }
                                                              //   }
        gluQuadricDrawStyle(Objects3D[0], GLU_FILL);          //   }
        gluQuadricNormals(Objects3D[0], GLU_SMOOTH);          //   }
        gluQuadricOrientation(Objects3D[0], GLU_OUTSIDE);     //   }
                                                              //   }
        Objects3D[1] = gluNewQuadric();                       //   }
        gluQuadricTexture(Objects3D[1], GL_TRUE);             //   }
                                                              //   } Coordinate
        gluQuadricDrawStyle(Objects3D[1], GLU_FILL);          //   }
        gluQuadricNormals(Objects3D[1], GLU_SMOOTH);          //   }  arrows
        gluQuadricOrientation(Objects3D[1], GLU_OUTSIDE);     //   }
                                                              //   }
        glNewList(startoflist + 1, GL_COMPILE);               //   }
        glBindTexture(GL_TEXTURE_2D, 0);                      //   }
        glColor4f(1, 1, 1, 0.2);                              //   }
        glPushMatrix();                                       //   }
                glRotatef(-90, 1, 0, 0);                      //   }
                gluCylinder(Objects3D[0], 2, 2, 150, 12, 1);  //   }
        glPopMatrix();                                        //   }
        glPushMatrix();                                       //   }
                glRotatef(-90, 1, 0, 0);                      //   }
                glTranslatef(0, 0, 150);                      //   }
                gluCylinder(Objects3D[0], 6, 0, 50, 12, 1);   //   }
        glPopMatrix();                                        //   }
        glPushMatrix();                                       //   }
                gluCylinder(Objects3D[0], 2, 2, 150, 12, 1);  //   }
        glPopMatrix();                                        //   }
        glPushMatrix();                                       //   }
                glTranslatef(0, 0, 150);                      //   }
                gluCylinder(Objects3D[0], 6, 0, 50, 12, 1);   //   }
        glPopMatrix();                                        //   }
        glPushMatrix();                                       //   }
                glRotatef(90, 0, 1, 0);                       //   }
                gluCylinder(Objects3D[0], 2, 2, 150, 12, 1);  //   }
        glPopMatrix();                                        //   }
        glPushMatrix();                                       //   }
                glRotatef(90, 0, 1, 0);                       //   }
                glTranslatef(0, 0, 150);                      //   }
                gluCylinder(Objects3D[0], 6, 0, 50, 12, 1);   //   }
        glPopMatrix();                                        //   }
                                                              //   }
                                                              //   }
        glEndList();                                          //   }

        draw = true; //Now we can safely render the scene
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *)
{
        delete bitmap;
        wglMakeCurrent(NULL, NULL);
        wglDeleteContext(hrc);
}
void __fastcall TForm1::SetPixelFormatDescr()
{
        hdc = GetDC(Form1->Handle);

        PIXELFORMATDESCRIPTOR pfd = {
    	sizeof(PIXELFORMATDESCRIPTOR),
        1,
        PFD_DRAW_TO_WINDOW | PFD_DOUBLEBUFFER /*| PFD_GENERIC_FORMAT*/,
        PFD_TYPE_RGBA,
        8,
        0,0,0,0,0,0,
        0,0,
        0,0,0,0,0,
        32,
        16,
        0,
        PFD_MAIN_PLANE,
        0,
        0,0,
    };
        PixelFormat = ChoosePixelFormat(hdc, &pfd);
        SetPixelFormat(hdc, PixelFormat, &pfd);

        hrc = wglCreateContext(hdc);
        if(hrc == NULL) ShowMessage(":-)/n hrc == NULL");
        if(!wglMakeCurrent(hdc, hrc)) ShowMessage("Could not MakeCurrent");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Perspective()
{
        if (!draw) return;
        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();

        if (w <= h) glOrtho (-nRange, nRange, -nRange*h/w, nRange*h/w, -nRange, nRange);
        else        glOrtho (-nRange*w/h, nRange*w/h, -nRange, nRange, -nRange, nRange);

        gluPerspective(0.05, 1.0, Near, Far);
        atx = cos(alf)*cos(tht);
        aty = sin(tht);
        atz = sin(alf)*cos(tht);
        gluLookAt( hx, hy, hz, hx + atx, hy + aty, hz + atz, 0.0, 1.0, 0.0 );

        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();
}
//---------------------------------------------------------------------------
float __fastcall TForm1::glSrfFunc(float i, float j)
{
     switch (formnum)
     {
     case 0 : return a*cos(sqrt(b*i*i + c*j*j)+dt+t);
     case 1 : return a*(i*i+j*j);
     case 2 : return a*(sin(b*i/18*M_PI + dt + t)+cos(c*j/18*M_PI+ dt +t));
     case 3 : return a*sgn(i*j);
     case 4 : return a*pow( (sin(b*i/18*M_PI + dt +t)), 5);
     case 5 : return a*fabs(sin(b*i*M_PI/16 + dt+t)*cos(c*j*M_PI/16 + dt+t));
     case 6 : return 0.01*a*(sinh(b*i + t)*cosh(c*j + t));
     }
//*/
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DrawScene()
{
     glPushMatrix();
     if (mode == GL_QUADS)
     {
      glBindTexture(GL_TEXTURE_2D, tnum);
      glColor3b(127, 127, 127);
     }
     else glColor3b(ntcl.r, ntcl.g, ntcl.b);

     glRotatef(st*10, 0, 1, 0);
     glBegin(mode);
     for (int i=-20; i<20; i++)
     for (int j=-20; j<20; j++)
     if (mode == GL_QUADS)
     {
          glTexCoord2f(0, 0);
          glVertex3f(ka*(i+1), glSrfFunc(i+1,j+1), ka*(j+1)  );
          glNormal3f(0, 1, 0);

          glTexCoord2f(1, 0);
          glVertex3f(ka*(i+1), glSrfFunc(i+1,j), ka*j      );
          glNormal3f(0, 1, 0);

          glTexCoord2f(1, 1);
          glVertex3f(ka*i,     glSrfFunc(i,j), ka*j      );
          glNormal3f(0, 1, 0);

          glTexCoord2f(0, 1);
          glVertex3f(ka*i,     glSrfFunc(i,j+1), ka*(j+1)  );
          glNormal3f(0, 1, 0);
     } else
     {
          glVertex3f(18*(i+1), glSrfFunc(i+1,j+1), 18*(j+1)  );
          glVertex3f(18*(i  ), glSrfFunc(i  ,j+1), 18*(j+1)  );

          glVertex3f(18*(i  ), glSrfFunc(i  ,j+1), 18*(j+1)  );
          glVertex3f(18*(i  ), glSrfFunc(i  ,j  ), 18*(j  )  );

          glVertex3f(18*(i  ), glSrfFunc(i  ,j  ), 18*(j  )  );
          glVertex3f(18*(i+1), glSrfFunc(i+1,j  ), 18*(j  )  );

          glVertex3f(18*(i+1), glSrfFunc(i+1,j  ), 18*(j  )  );
          glVertex3f(18*(i+1), glSrfFunc(i+1,j+1), 18*(j+1)  );
     }

     glEnd();
     glPopMatrix();

     glPushMatrix();
     glTranslatef(0, 30, 0);
     glRotatef(st*10, 0, 1, 0);
     glCallList(startoflist + 1 );
     glPopMatrix();
}
//---------------------------------------------------------------------------
int __fastcall TForm1::sgn(GLfloat argument)
{
        int re = 0;
        if (argument > 0.00) re = +1;
        if (argument == 0.0) re = 00;
        if (argument < 0.00) re = -1;
        return re;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Light()
{
      GLfloat MaterialAmbient[]                       = {0.3, 0.3, 0.3, 1.0},
              MaterialDiffuse[]                       = {1.0, 1.0, 1.0, 1.0},
              MaterialEmission[]                      = {0.0, 0.0, 0.0, 1.0},
              MaterialShininess[]                     = {50.0},
              MaterialSpecular[]                      = {10.7, 0.7, 0.7, 1.0};

      GLfloat LightModelAmbient[]                     = {0.0, 0.0, 0.0, 1.0},
              LightModelLocalViewer[]                 = {0.0},
              LightModelTwoSide[]                     = {0.0};

      GLfloat Light0Ambient[]                         = {0.3, 0.3, 0.3, 1.0},
              Light0Diffuse[]                         = {1.0, 1.0, 1.0, 1.0},
              Light0Specular[]                        = {1.0, 1.0, 1.0, 1.0},
              Light0SpotExponent[]                    = {0.0},
              Light0SpotCutOff[]                      = {90.0},
              Light0ConstantAttenuation[]             = {0.0},
              Light0LinearAttenuation[]               = {0.001},
              Light0QuadraticAttenuation[]            = {0.0},
              Light0Position[]                        = {400.0, 500.0, 400.0, 1.0},
              Light0Spot[]                            = {0.0, -1.0, -0.01};

      glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,              MaterialAmbient);
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE,              MaterialDiffuse);
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION,             MaterialEmission);
      glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS,            MaterialShininess);
      glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR,             MaterialSpecular);

      glLightModelfv(GL_LIGHT_MODEL_AMBIENT,          LightModelAmbient);
      glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER,     LightModelLocalViewer);
      glLightModelfv(GL_LIGHT_MODEL_TWO_SIDE,         LightModelTwoSide);

      glLightfv(GL_LIGHT0, GL_AMBIENT,                Light0Ambient);
      glLightfv(GL_LIGHT0, GL_DIFFUSE,                Light0Diffuse);
      glLightfv(GL_LIGHT0, GL_POSITION,               Light0Position);
      glLightfv(GL_LIGHT0, GL_SPECULAR,               Light0Specular);
      glLightfv(GL_LIGHT0, GL_SPOT_CUTOFF,            Light0SpotCutOff);
      glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION,         Light0Spot);
      glLightfv(GL_LIGHT0, GL_SPOT_EXPONENT,          Light0SpotExponent);
      glLightfv(GL_LIGHT0, GL_CONSTANT_ATTENUATION,   Light0ConstantAttenuation);
      glLightfv(GL_LIGHT0, GL_LINEAR_ATTENUATION,     Light0LinearAttenuation);
      glLightfv(GL_LIGHT0, GL_QUADRATIC_ATTENUATION,  Light0QuadraticAttenuation);

//      enable lighting here:

      glColorMaterial(GL_FRONT_AND_BACK, GL_SPECULAR);
      glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      glShadeModel(GL_SMOOTH);
      glEnable(GL_LIGHTING);
      glEnable(GL_LIGHT0);
      glEnable(GL_COLOR_MATERIAL);

}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::SetupTextures()
{
    GLubyte bits[64][64][4];
    nrt = 1;
    glEnable(GL_TEXTURE_2D);
    while ( true )
    {
    try
    {
    bitmap->LoadFromFile("Textures/00"+IntToStr(nrt)+".bmp");
    }
    catch (...) { return; }
    for(int i = 0; i < 64; i++)
    {
    	for(int j = 0; j < 64; j++)
        {
            bits[j][63-i][0]= (GLbyte)GetRValue(bitmap->Canvas->Pixels[i][j]);
            bits[j][63-i][1]= (GLbyte)GetGValue(bitmap->Canvas->Pixels[i][j]);
            bits[j][63-i][2]= (GLbyte)GetBValue(bitmap->Canvas->Pixels[i][j]);
            bits[j][63-i][3]= (GLbyte)255;
        }
    }
    tex.Length = nrt;
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glGenTextures(1, &tex[nrt-1]);
    glBindTexture(GL_TEXTURE_2D, tex[nrt-1]);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
    gluBuild2DMipmaps(GL_TEXTURE_2D, 4, 64, 64, GL_RGBA, GL_UNSIGNED_BYTE, bits );
    nrt++;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer2Timer(TObject *)
{
     Edit1->Text = IntToStr(fps);
     fps=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Panel1MouseMove(TObject *, TShiftState Shift, int X, int Y)
{
     int delta_x = 0.5*(X-ox);
     int delta_y = 0.5*(Y-oy);
     0.5*(Y-oy);
     if (Shift.Contains(ssLeft))
     {
     alf += delta_x*0.005;
     tht += delta_y*0.005;
     }
     if (Shift.Contains(ssRight))
     {
     hx += delta_y*cos(alf)*cos(tht);
     hy += delta_y*sin(tht);
     hz += delta_y*sin(alf)*cos(tht);
     hx += delta_x*cos(alf+M_PI_2)*cos(tht);
     hz += delta_x*sin(alf+M_PI_2)*cos(tht);
     }
     if (Shift.Contains(ssMiddle))
     {
     hy         =  200;
     hx         =  400;
     hz         =  400;
     alf        = -2.356;
     tht        = -0.333;
     }
     ox = X;
     oy = Y;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *)
{
     if (rot->Checked) st += 0.01;
     if (N1->Checked)  dt += 0.01;
     if (GetAsyncKeyState(VK_UP))
     {
     hx += 5*cos(alf)*cos(tht);
     hy += 5*sin(tht);
     hz += 5*sin(alf)*cos(tht);
     }
     if (GetAsyncKeyState(VK_DOWN))
     {
     hx -= 5*cos(alf)*cos(tht);
     hy -= 5*sin(tht);
     hz -= 5*sin(alf)*cos(tht);
     }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::rotClick(TObject *)
{
     rot->Checked = !rot->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N1Click(TObject *)
{
     N1->Checked = !N1->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N3Click(TObject *)
{
     Form2->Show();
}
//---------------------------------------------------------------------------


